#version 450
 
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    vec3 gViewPositionVec3;
    float gfTime;
    vec4 gFrameBufferSizeVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    float gfFadeValue;
    vec4 gaSkinMatrixRowsVec4[225];
    vec4 gaPrevSkinMatrixRowsVec4[225];
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gBboxDepthAndClips;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _62;

layout(location = 0) in vec4 mkLocalPositionVec4;
layout(location = 1) in vec4 mkTexCoordsVec4;
layout(location = 6) in vec4 mkWeightsVec4;
layout(location = 5) in vec4 mkJointsVec4;
layout(location = 0) out VertexBlock
{
    vec4 mScreenSpacePositionVec4;
    vec4 mTexCoordsVec4;
} Out;

layout(location = 7) in vec4 mkLocalNormalVec4;
layout(location = 3) in vec4 mkTangentVec4;

mat4 _1658;

void main()
{
    vec4 _1607 = mkLocalPositionVec4;
    _1607.w = 1.0;
    int _1521 = int(mkJointsVec4.x) * 3;
    mat4 _1610 = _1658;
    _1610[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1521];
    mat4 _1612 = _1610;
    _1612[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1521 + 1];
    mat4 _1614 = _1612;
    _1614[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1521 + 2];
    mat4 _1616 = _1614;
    _1616[3] = vec4(0.0, 0.0, 0.0, 1.0);
    vec4 _1459 = (_1607 * _1616) * mkWeightsVec4.x;
    vec4 _1660;
    if (mkWeightsVec4.y > 0.001000000047497451305389404296875)
    {
        int _1542 = int(mkJointsVec4.y) * 3;
        mat4 _1621 = _1658;
        _1621[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1542];
        mat4 _1623 = _1621;
        _1623[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1542 + 1];
        mat4 _1625 = _1623;
        _1625[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1542 + 2];
        mat4 _1627 = _1625;
        _1627[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1660 = _1459 + ((_1607 * _1627) * mkWeightsVec4.y);
    }
    else
    {
        _1660 = _1459;
    }
    vec4 _1663;
    if (mkWeightsVec4.z > 0.001000000047497451305389404296875)
    {
        int _1563 = int(mkJointsVec4.z) * 3;
        mat4 _1632 = _1658;
        _1632[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1563];
        mat4 _1634 = _1632;
        _1634[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1563 + 1];
        mat4 _1636 = _1634;
        _1636[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1563 + 2];
        mat4 _1638 = _1636;
        _1638[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1663 = _1660 + ((_1607 * _1638) * mkWeightsVec4.z);
    }
    else
    {
        _1663 = _1660;
    }
    vec4 _1664;
    if (mkWeightsVec4.w > 0.001000000047497451305389404296875)
    {
        int _1584 = int(mkJointsVec4.w) * 3;
        mat4 _1643 = _1658;
        _1643[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1584];
        mat4 _1645 = _1643;
        _1645[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1584 + 1];
        mat4 _1647 = _1645;
        _1647[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1584 + 2];
        mat4 _1649 = _1647;
        _1649[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1664 = _1663 + ((_1607 * _1649) * mkWeightsVec4.w);
    }
    else
    {
        _1664 = _1663;
    }
    Out.mTexCoordsVec4 = vec4(mkTexCoordsVec4.x, mkTexCoordsVec4.y, mkTexCoordsVec4.z, mkTexCoordsVec4.w);
    vec4 _1605 = _62.lUniforms.mpPerFrame.gViewProjectionMat4 * (_62.lUniforms.mpCommonPerMesh.gWorldMat4 * (_1664 / vec4(max(_1664.w, 9.9999999747524270787835121154785e-07))));
    vec4 _1657 = _1605;
    _1657.z = 0.5 - (max(_1605.z, -1.0) * 0.5);
    Out.mScreenSpacePositionVec4 = _1657;
    gl_Position = _1657;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
// gl_Position.x -= vk3d_params.stereo.x * (gl_Position.w - vk3d_params.stereo.y); 

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
// gl_Position.x += vk3d_params.stereo.x * (gl_Position.w - vk3d_params.stereo.y); 
}


